#!/usr/bin/env python

# create a rendering window and renderer
ren1 = vtk.vtkRenderer()
renWin = vtk.vtkRenderWindow()
renWin.AddRenderer(ren1)
renWin.StereoCapableWindowOn()
iren = vtk.vtkRenderWindowInteractor()
iren.SetRenderWindow(renWin)
reader = vtk.vtkGenericEnSightReader()
reader.SetCaseFileName("" + str(VTK_DATA_ROOT) + "/Data/EnSight/elements.case")
reader.Update()
geom0 = vtk.vtkGeometryFilter()
geom0.SetInputConnection(reader.GetOutputPort())
geom1 = vtk.vtkGeometryFilter()
geom1.SetInput(reader.GetOutput(1))
mapper0 = vtk.vtkPolyDataMapper()
mapper0.SetInputConnection(geom0.GetOutputPort())
mapper0.SetColorModeToMapScalars()
mapper0.SetScalarModeToUsePointFieldData()
mapper0.ColorByArrayComponent("pointScalars",0)
mapper0.SetScalarRange(0,112)
mapper1 = vtk.vtkPolyDataMapper()
mapper1.SetInputConnection(geom1.GetOutputPort())
mapper1.SetColorModeToMapScalars()
mapper1.SetScalarModeToUsePointFieldData()
mapper1.ColorByArrayComponent("pointScalars",0)
mapper1.SetScalarRange(0,112)
actor0 = vtk.vtkActor()
actor0.SetMapper(mapper0)
actor1 = vtk.vtkActor()
actor1.SetMapper(mapper1)
# assign our actor to the renderer
ren1.AddActor(actor0)
ren1.AddActor(actor1)
# enable user interface interactor
iren.Initialize()
# prevent the tk window from showing up then start the event loop
# --- end of script --
