#!/usr/bin/env python

# Derived from Cursor3D.  This script increases the coverage of the
# vtkImageInplaceFilter super class.
# global values
CURSOR_X = 20
CURSOR_Y = 20
CURSOR_Z = 20
IMAGE_MAG_X = 2
IMAGE_MAG_Y = 2
IMAGE_MAG_Z = 1
# pipeline stuff
reader = vtk.vtkSLCReader()
reader.SetFileName("" + str(VTK_DATA_ROOT) + "/Data/nut.slc")
# make the image a little biger
magnify1 = vtk.vtkImageMagnify()
magnify1.SetInputConnection(reader.GetOutputPort())
magnify1.SetMagnificationFactors(IMAGE_MAG_X,IMAGE_MAG_Y,IMAGE_MAG_Z)
magnify1.ReleaseDataFlagOn()
magnify2 = vtk.vtkImageMagnify()
magnify2.SetInputConnection(reader.GetOutputPort())
magnify2.SetMagnificationFactors(IMAGE_MAG_X,IMAGE_MAG_Y,IMAGE_MAG_Z)
magnify2.ReleaseDataFlagOn()
# a filter that does in place processing (magnify ReleaseDataFlagOn)
cursor = vtk.vtkImageCursor3D()
cursor.SetInputConnection(magnify1.GetOutputPort())
cursor.SetCursorPosition(expr.expr(globals(), locals(),["CURSOR_X","*","IMAGE_MAG_X"]),expr.expr(globals(), locals(),["CURSOR_Y","*","IMAGE_MAG_Y"]),expr.expr(globals(), locals(),["CURSOR_Z","*","IMAGE_MAG_Z"]))
cursor.SetCursorValue(255)
cursor.SetCursorRadius(expr.expr(globals(), locals(),["50","*","IMAGE_MAG_X"]))
# stream to increase coverage of in place filter.
# put thge two together in one image
imageAppend = vtk.vtkImageAppend()
imageAppend.SetAppendAxis(0)
imageAppend.AddInput(magnify2.GetOutput())
imageAppend.AddInput(cursor.GetOutput())
viewer = vtk.vtkImageViewer()
viewer.SetInputConnection(imageAppend.GetOutputPort())
viewer.SetZSlice(expr.expr(globals(), locals(),["CURSOR_Z","*","IMAGE_MAG_Z"]))
viewer.SetColorWindow(200)
viewer.SetColorLevel(80)
#viewer DebugOn
viewer.Render()
viewer.SetPosition(50,50)
#make interface
viewer.Render()
# --- end of script --
