#!/usr/bin/env python

# A script to test the stencil filter.
# removes all but a sphere.
reader = vtk.vtkPNGReader()
reader.SetDataSpacing(0.8,0.8,1.5)
reader.SetDataOrigin(0.0,0.0,0.0)
reader.SetFileName("" + str(VTK_DATA_ROOT) + "/Data/fullhead15.png")
sphere = vtk.vtkSphere()
sphere.SetCenter(128,128,0)
sphere.SetRadius(80)
functionToStencil = vtk.vtkImplicitFunctionToImageStencil()
functionToStencil.SetInput(sphere)
# test manual updating of stencil
stencilOriginal = functionToStencil.GetOutput()
stencilOriginal.SetSpacing(0.8,0.8,1.5)
stencilOriginal.SetOrigin(0.0,0.0,0.0)
stencilOriginal.SetUpdateExtent(0,255,0,255,0,0)
stencilOriginal.Update()
# test making a copying of the stencil (for coverage)
stencilCopy = stencilOriginal.NewInstance()
stencilCopy.DeepCopy(stencilOriginal)
shiftScale = vtk.vtkImageShiftScale()
shiftScale.SetInputConnection(reader.GetOutputPort())
shiftScale.SetScale(0.2)
stencil = vtk.vtkImageStencil()
stencil.SetInputConnection(reader.GetOutputPort())
stencil.SetBackgroundInput(shiftScale.GetOutput())
stencil.SetStencil(stencilCopy)
stencilCopy.UnRegister(reader)
viewer = vtk.vtkImageViewer()
viewer.SetInputConnection(stencil.GetOutputPort())
viewer.SetZSlice(0)
viewer.SetColorWindow(2000)
viewer.SetColorLevel(1000)
viewer.Render()
# --- end of script --
