#!/usr/bin/env python

gauss = vtk.vtkImageGaussianSource()
gauss.SetWholeExtent(0,30,0,30,0,2)
gauss.SetCenter(18,12,0)
gauss.SetMaximum(1.0)
gauss.SetStandardDeviation(6.0)
gauss.Update()
translator = vtk.vtkBranchExtentTranslator()
translator.SetOriginalSource(gauss.GetOutput())
gauss.GetOutput().SetExtentTranslator(translator)
clip1 = vtk.vtkImageClip()
clip1.SetOutputWholeExtent(7,28,0,15,1,1)
clip1.SetInputConnection(gauss.GetOutputPort())
surf1 = vtk.vtkDataSetSurfaceFilter()
surf1.SetInputConnection(clip1.GetOutputPort())
tf1 = vtk.vtkTriangleFilter()
tf1.SetInputConnection(surf1.GetOutputPort())
mapper1 = vtk.vtkPolyDataMapper()
mapper1.SetInputConnection(tf1.GetOutputPort())
mapper1.SetScalarRange(0,1)
mapper1.SetNumberOfPieces(4)
mapper1.SetPiece(1)
actor1 = vtk.vtkActor()
actor1.SetMapper(mapper1)
actor1.SetPosition(0,0,0)
# For coverage, a case where all four sides get clipped by the whole extent.
clip2 = vtk.vtkImageClip()
clip2.SetOutputWholeExtent(16,18,3,10,0,0)
clip2.SetInputConnection(gauss.GetOutputPort())
surf2 = vtk.vtkDataSetSurfaceFilter()
surf2.SetInputConnection(clip2.GetOutputPort())
tf2 = vtk.vtkTriangleFilter()
tf2.SetInputConnection(surf2.GetOutputPort())
mapper2 = vtk.vtkPolyDataMapper()
mapper2.SetInputConnection(tf2.GetOutputPort())
mapper2.SetScalarRange(0,1)
mapper2.SetNumberOfPieces(4)
mapper2.SetPiece(1)
actor2 = vtk.vtkActor()
actor2.SetMapper(mapper2)
actor2.SetPosition(15,0,0)
# nothing in intersection (empty case)
clip3 = vtk.vtkImageClip()
clip3.SetOutputWholeExtent(1,10,0,15,0,2)
clip3.SetInputConnection(gauss.GetOutputPort())
surf3 = vtk.vtkDataSetSurfaceFilter()
surf3.SetInputConnection(clip3.GetOutputPort())
tf3 = vtk.vtkTriangleFilter()
tf3.SetInputConnection(surf3.GetOutputPort())
mapper3 = vtk.vtkPolyDataMapper()
mapper3.SetInputConnection(tf3.GetOutputPort())
mapper3.SetScalarRange(0,1)
mapper3.SetNumberOfPieces(4)
mapper3.SetPiece(1)
actor3 = vtk.vtkActor()
actor3.SetMapper(mapper3)
actor3.SetPosition(30,0,0)
ren = vtk.vtkRenderer()
ren.AddActor(actor1)
ren.AddActor(actor2)
ren.AddActor(actor3)
renWin = vtk.vtkRenderWindow()
renWin.AddRenderer(ren)
#set cam [ren GetActiveCamera]
#ren ResetCamera
iren = vtk.vtkRenderWindowInteractor()
iren.SetRenderWindow(renWin)
iren.Initialize()
renWin.Render()
# break loop to avoid a memory leak.
translator.SetOriginalSource(None)
# --- end of script --
