#!/usr/bin/env python

math = vtk.vtkMath()
math.RandomSeed(22)
pf = vtk.vtkParallelFactory()
pf.RegisterFactory(pf)
pl3d = vtk.vtkPLOT3DReader()
pl3d.SetXYZFileName("" + str(VTK_DATA_ROOT) + "/Data/combxyz.bin")
pl3d.SetQFileName("" + str(VTK_DATA_ROOT) + "/Data/combq.bin")
pl3d.SetScalarFunctionNumber(100)
dst = vtk.vtkDataSetTriangleFilter()
dst.SetInputConnection(pl3d.GetOutputPort())
extract = vtk.vtkExtractUnstructuredGridPiece()
extract.SetInputConnection(dst.GetOutputPort())
cf = vtk.vtkContourFilter()
cf.SetInputConnection(extract.GetOutputPort())
cf.SetValue(0,0.24)
pdn = vtk.vtkPolyDataNormals()
pdn.SetInputConnection(cf.GetOutputPort())
ps = vtk.vtkPieceScalars()
ps.SetInputConnection(pdn.GetOutputPort())
mapper = vtk.vtkPolyDataMapper()
mapper.SetInputConnection(ps.GetOutputPort())
mapper.SetNumberOfPieces(3)
actor = vtk.vtkActor()
actor.SetMapper(mapper)
ren = vtk.vtkRenderer()
ren.AddActor(actor)
ren.ResetCamera()
camera = ren.GetActiveCamera()
#$camera SetPosition 68.1939 -23.4323 12.6465
#$camera SetViewUp 0.46563 0.882375 0.0678508  
#$camera SetFocalPoint 3.65707 11.4552 1.83509 
#$camera SetClippingRange 59.2626 101.825 
renWin = vtk.vtkRenderWindow()
renWin.AddRenderer(ren)
iren = vtk.vtkRenderWindowInteractor()
iren.SetRenderWindow(renWin)
iren.Initialize()
# --- end of script --
